'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function clusterByKey(bucket, keyer) {
  var bins = [];
  var keyToBin = {};

  for (var str in bucket) {
    var count = bucket[str];
    var key = keyer(str);
    var bin = keyToBin[key];

    if (!bin) {
      bin = {
        key: key,
        name: str,
        count: 0,
        bucket: {}
      };
      keyToBin[key] = bin;
      bins.push(bin);
    } else {
      // Maybe change name. We do it in this loop so we're O(n)
      var maxCount = bin.bucket[bin.name];

      if (count > maxCount || count === maxCount && str.localeCompare(bin.name) < 0) {
        bin.name = str;
      }
    }

    bin.count += count;
    bin.bucket[str] = count;
  }

  return bins;
}

exports.clusterByKey = clusterByKey;
